
//Modified By Sanjay Surage On 28/04/2023



#include <ArduinoBLE.h>
 
BLEService ledService("19B10000-E8F2-537E-4F6C-D104768A1214"); // Bluetooth® Low Energy LED Service
 
// Bluetooth® Low Energy LED Switch Characteristic - custom 128-bit UUID, read and writable by central
BLEByteCharacteristic switchCharacteristic("19B10001-E8F2-537E-4F6C-D104768A1214", BLERead | BLEWrite);
 
const int led1 = 9; 
const int led2 = 10; 
 
 
int Rvalue; // received value from Bluetooth Application
 
 
void setup() {
  Serial.begin(9600); 
   
  // Set all the Relays as output
  pinMode(led1, OUTPUT);
   pinMode(led2, OUTPUT);
     
   
  // begin initialization
  if (!BLE.begin()) {
    Serial.println("starting Bluetooth® Low Energy module failed!");
 
    while (1);
  }
 
  // set advertised local name and service UUID:
  BLE.setLocalName("VIGYAN ASHRAM FABLAB");            // this will appear in the App search result.
  BLE.setAdvertisedService(ledService);
 
  // add the characteristic to the service
  ledService.addCharacteristic(switchCharacteristic);
 
  // add service
 // BLE.addService(ledService);
 
  // set the initial value for the characeristic:
  switchCharacteristic.writeValue(0);
 

}
 
void loop() {
  // listen for Bluetooth® Low Energy peripherals to connect:
  BLEDevice central = BLE.central();
 
  // if a central is connected to peripheral:
  if (central) {
    Serial.print("Connected to system: ");
    // print the central's MAC address:
    Serial.println(central.address());
 
    
  while (central.connected()) {
        if (switchCharacteristic.written()) {
          Rvalue=switchCharacteristic.value(); // received value is stored in variable Rvalue.
 
          // we check the received commands and then accordingly control 
          // all the relays.
          
          if (Rvalue==0) {  
            Serial.println(switchCharacteristic.value() );
            Serial.println("led1 OFF");
            digitalWrite(led1, LOW); // changed from HIGH to LOW       
          } 
          
          else if(Rvalue==1){                              
            Serial.println(F("led1 ON"));
            digitalWrite(led1, HIGH); // changed from LOW to HIGH     
          }
          
          else  if (Rvalue==2) {  
            Serial.println(switchCharacteristic.value() );
            Serial.println("led2 OFF");
            digitalWrite(led2, LOW); // changed from HIGH to LOW       
          } 
          else if(Rvalue==3){                              
            Serial.println(F("led2 ON"));
            digitalWrite(led2, HIGH); // changed from LOW to HIGH     
          }
         
        }
      }
 
    // when the central disconnects, print it out:
    Serial.print(F("Disconnected from system: "));
    Serial.println(central.address());
  }
}
